/*
 * 银行信息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class BankInfoController : BaseController
    {
        public BankInfoController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 银行信息列表

        /// <summary>
        /// 根据条件查询银行信息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(BankInfo data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "BankName:\"" + data.BankName + "\",";
Condition += "UnitedBankNo:\"" + data.UnitedBankNo + "\",";
Condition += "UnitedBankName:\"" + data.UnitedBankName + "\",";
Condition += "BankNameAbbr:\"" + data.BankNameAbbr + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询银行信息列表

        /// <summary>
        /// 银行信息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(BankInfo data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("BankName", "2"); //银行全称
Fields.Add("UnitedBankNo", "2"); //银行总行联行号
Fields.Add("UnitedBankName", "2"); //总行名称
Fields.Add("BankNameAbbr", "2"); //银行简称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("BankInfo", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }
            return Json(obj);
        }

        #endregion

        #region 增加银行信息

        /// <summary>
        /// 增加或修改银行信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加银行信息

        /// <summary>
        /// 增加或修改银行信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(BankInfo data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("BankName", data.BankName); //银行全称
Fields.Add("BankCode", data.BankCode); //银行编码
Fields.Add("UnitedBankNo", data.UnitedBankNo); //银行总行联行号
Fields.Add("UnitedBankName", data.UnitedBankName); //总行名称
Fields.Add("BankNameAbbr", data.BankNameAbbr); //银行简称

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("BankInfo", Fields, 0);
            AddSysLog(data.Id.ToString(), "BankInfo", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改银行信息

        /// <summary>
        /// 增加或修改银行信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            BankInfo editData = db.BankInfo.FirstOrDefault(m => m.Id == Id) ?? new BankInfo();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改银行信息

        /// <summary>
        /// 增加或修改银行信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(BankInfo data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("BankName", data.BankName); //银行全称
Fields.Add("BankCode", data.BankCode); //银行编码
Fields.Add("UnitedBankNo", data.UnitedBankNo); //银行总行联行号
Fields.Add("UnitedBankName", data.UnitedBankName); //总行名称
Fields.Add("BankNameAbbr", data.BankNameAbbr); //银行简称

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("BankInfo", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"BankInfo","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除银行信息信息

        /// <summary>
        /// 删除银行信息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"BankInfo","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("BankInfo", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"BankInfo","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("BankInfo", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"BankInfo","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("BankInfo", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("BankInfo", Sort, Id);
            
            AddSysLog(Id.ToString(), "BankInfo", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.BankInfo.Add(new BankInfo()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "BankInfo", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(BankInfo data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("BankName", "2"); //银行全称
Fields.Add("UnitedBankNo", "2"); //银行总行联行号
Fields.Add("UnitedBankName", "2"); //总行名称
Fields.Add("BankNameAbbr", "2"); //银行简称

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("BankInfo", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "BankInfo", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
